Index: sym_hipd.c
===================================================================
--- sym_hipd.c	(revision 294669)
+++ sym_hipd.c	(working copy)
@@ -6296,14 +6296,13 @@ static	ccb_p sym_get_ccb (hcb_p np, u_char tn, u_c
 			goto out_free;
 	} else {
 		/*
-		 *  If we have been asked for a tagged command.
+		 *  If we have been asked for a tagged command, refuse
+		 *  to overlap with an existing untagged one.
 		 */
 		if (tag_order) {
+			if (lp->busy_itl != 0)
+				goto out_free;
 			/*
-			 *  Debugging purpose.
-			 */
-			assert(lp->busy_itl == 0);
-			/*
 			 *  Allocate resources for tags if not yet.
 			 */
 			if (!lp->cb_tags) {
@@ -6335,22 +6334,17 @@ static	ccb_p sym_get_ccb (hcb_p np, u_char tn, u_c
 		 *  one, refuse to overlap this untagged one.
 		 */
 		else {
+			if (lp->busy_itlq != 0 || lp->busy_itl != 0)
+				goto out_free;
 			/*
-			 *  Debugging purpose.
-			 */
-			assert(lp->busy_itl == 0 && lp->busy_itlq == 0);
-			/*
 			 *  Count this nexus for this LUN.
 			 *  Set up the CCB bus address for reselection.
 			 *  Toggle reselect path to untagged.
 			 */
-			if (++lp->busy_itl == 1) {
-				lp->head.itl_task_sa = cpu_to_scr(cp->ccb_ba);
-				lp->head.resel_sa =
-				      cpu_to_scr(SCRIPTA_BA (np, resel_no_tag));
-			}
-			else
-				goto out_free;
+			lp->busy_itl = 1;
+			lp->head.itl_task_sa = cpu_to_scr(cp->ccb_ba);
+			lp->head.resel_sa =
+			      cpu_to_scr(SCRIPTA_BA (np, resel_no_tag));
 		}
 	}
 	/*
@@ -6396,7 +6390,7 @@ static void sym_free_ccb(hcb_p np, ccb_p cp)
 	 */
 	if (lp) {
 		/*
-		 *  If tagged, release the tag, set the relect path
+		 *  If tagged, release the tag, set the reselect path.
 		 */
 		if (cp->tag != NO_TAG) {
 			/*
@@ -6417,7 +6411,7 @@ static void sym_free_ccb(hcb_p np, ccb_p cp)
 			 *  and uncount this CCB.
 			 */
 			lp->head.itl_task_sa = cpu_to_scr(np->bad_itl_ba);
-			--lp->busy_itl;
+			lp->busy_itl = 0;
 		}
 		/*
 		 *  If no JOB active, make the LUN reselect path invalid.
